diff --git a/MAINTAINERS b/MAINTAINERS
index 16e614606ac1..1c2787d22132 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -7377,7 +7377,7 @@ L:	dri-devel@lists.freedesktop.org
 L:	linux-fbdev@vger.kernel.org
 S:	Maintained
 T:	git git://git.kernel.org/pub/scm/linux/kernel/git/andy/linux-fbtft.git
-F:	drivers/staging/fbtft/
+F:	drivers/video/fbtft/
 
 FC0011 TUNER DRIVER
 M:	Michael Buesch <m@bues.ch>
diff --git a/drivers/staging/Kconfig b/drivers/staging/Kconfig
index 8d41fdd40657..0ed757061e58 100644
--- a/drivers/staging/Kconfig
+++ b/drivers/staging/Kconfig
@@ -72,8 +72,6 @@ source "drivers/staging/unisys/Kconfig"
 
 source "drivers/staging/clocking-wizard/Kconfig"
 
-source "drivers/staging/fbtft/Kconfig"
-
 source "drivers/staging/most/Kconfig"
 
 source "drivers/staging/ks7010/Kconfig"
diff --git a/drivers/staging/Makefile b/drivers/staging/Makefile
index 02b01949b94e..77d8e385498b 100644
--- a/drivers/staging/Makefile
+++ b/drivers/staging/Makefile
@@ -26,7 +26,6 @@ obj-$(CONFIG_FIREWIRE_SERIAL)	+= fwserial/
 obj-$(CONFIG_GS_FPGABOOT)	+= gs_fpgaboot/
 obj-$(CONFIG_UNISYSSPAR)	+= unisys/
 obj-$(CONFIG_COMMON_CLK_XLNX_CLKWZRD)	+= clocking-wizard/
-obj-$(CONFIG_FB_TFT)		+= fbtft/
 obj-$(CONFIG_MOST)		+= most/
 obj-$(CONFIG_KS7010)		+= ks7010/
 obj-$(CONFIG_GREYBUS)		+= greybus/
diff --git a/drivers/video/Kconfig b/drivers/video/Kconfig
index 427a993c7f57..5903cb4db1a4 100644
--- a/drivers/video/Kconfig
+++ b/drivers/video/Kconfig
@@ -21,6 +21,7 @@ source "drivers/gpu/drm/Kconfig"
 
 menu "Frame buffer Devices"
 source "drivers/video/fbdev/Kconfig"
+source "drivers/video/fbtft/Kconfig"
 endmenu
 
 source "drivers/video/backlight/Kconfig"
diff --git a/drivers/video/Makefile b/drivers/video/Makefile
index df7650adede9..323d002f404d 100644
--- a/drivers/video/Makefile
+++ b/drivers/video/Makefile
@@ -8,6 +8,7 @@ obj-$(CONFIG_LOGO)		  += logo/
 obj-y				  += backlight/
 
 obj-y				  += fbdev/
+obj-y				  += fbtft/
 
 obj-$(CONFIG_VIDEOMODE_HELPERS) += display_timing.o videomode.o
 ifeq ($(CONFIG_OF),y)
diff --git a/drivers/staging/fbtft/Kconfig b/drivers/video/fbtft/Kconfig
similarity index 100%
rename from drivers/staging/fbtft/Kconfig
rename to drivers/video/fbtft/Kconfig
diff --git a/drivers/staging/fbtft/Makefile b/drivers/video/fbtft/Makefile
similarity index 100%
rename from drivers/staging/fbtft/Makefile
rename to drivers/video/fbtft/Makefile
diff --git a/drivers/staging/fbtft/README b/drivers/video/fbtft/README
similarity index 100%
rename from drivers/staging/fbtft/README
rename to drivers/video/fbtft/README
diff --git a/drivers/staging/fbtft/TODO b/drivers/video/fbtft/TODO
similarity index 100%
rename from drivers/staging/fbtft/TODO
rename to drivers/video/fbtft/TODO
diff --git a/drivers/staging/fbtft/fb_agm1264k-fl.c b/drivers/video/fbtft/fb_agm1264k-fl.c
similarity index 100%
rename from drivers/staging/fbtft/fb_agm1264k-fl.c
rename to drivers/video/fbtft/fb_agm1264k-fl.c
diff --git a/drivers/staging/fbtft/fb_bd663474.c b/drivers/video/fbtft/fb_bd663474.c
similarity index 100%
rename from drivers/staging/fbtft/fb_bd663474.c
rename to drivers/video/fbtft/fb_bd663474.c
diff --git a/drivers/staging/fbtft/fb_hx8340bn.c b/drivers/video/fbtft/fb_hx8340bn.c
similarity index 100%
rename from drivers/staging/fbtft/fb_hx8340bn.c
rename to drivers/video/fbtft/fb_hx8340bn.c
diff --git a/drivers/staging/fbtft/fb_hx8347d.c b/drivers/video/fbtft/fb_hx8347d.c
similarity index 100%
rename from drivers/staging/fbtft/fb_hx8347d.c
rename to drivers/video/fbtft/fb_hx8347d.c
diff --git a/drivers/staging/fbtft/fb_hx8353d.c b/drivers/video/fbtft/fb_hx8353d.c
similarity index 100%
rename from drivers/staging/fbtft/fb_hx8353d.c
rename to drivers/video/fbtft/fb_hx8353d.c
diff --git a/drivers/staging/fbtft/fb_hx8357d.c b/drivers/video/fbtft/fb_hx8357d.c
similarity index 100%
rename from drivers/staging/fbtft/fb_hx8357d.c
rename to drivers/video/fbtft/fb_hx8357d.c
diff --git a/drivers/staging/fbtft/fb_hx8357d.h b/drivers/video/fbtft/fb_hx8357d.h
similarity index 100%
rename from drivers/staging/fbtft/fb_hx8357d.h
rename to drivers/video/fbtft/fb_hx8357d.h
diff --git a/drivers/staging/fbtft/fb_ili9163.c b/drivers/video/fbtft/fb_ili9163.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9163.c
rename to drivers/video/fbtft/fb_ili9163.c
diff --git a/drivers/staging/fbtft/fb_ili9320.c b/drivers/video/fbtft/fb_ili9320.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9320.c
rename to drivers/video/fbtft/fb_ili9320.c
diff --git a/drivers/staging/fbtft/fb_ili9325.c b/drivers/video/fbtft/fb_ili9325.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9325.c
rename to drivers/video/fbtft/fb_ili9325.c
diff --git a/drivers/staging/fbtft/fb_ili9340.c b/drivers/video/fbtft/fb_ili9340.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9340.c
rename to drivers/video/fbtft/fb_ili9340.c
diff --git a/drivers/staging/fbtft/fb_ili9341.c b/drivers/video/fbtft/fb_ili9341.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9341.c
rename to drivers/video/fbtft/fb_ili9341.c
diff --git a/drivers/staging/fbtft/fb_ili9481.c b/drivers/video/fbtft/fb_ili9481.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9481.c
rename to drivers/video/fbtft/fb_ili9481.c
diff --git a/drivers/staging/fbtft/fb_ili9486.c b/drivers/video/fbtft/fb_ili9486.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ili9486.c
rename to drivers/video/fbtft/fb_ili9486.c
diff --git a/drivers/staging/fbtft/fb_pcd8544.c b/drivers/video/fbtft/fb_pcd8544.c
similarity index 100%
rename from drivers/staging/fbtft/fb_pcd8544.c
rename to drivers/video/fbtft/fb_pcd8544.c
diff --git a/drivers/staging/fbtft/fb_ra8875.c b/drivers/video/fbtft/fb_ra8875.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ra8875.c
rename to drivers/video/fbtft/fb_ra8875.c
diff --git a/drivers/staging/fbtft/fb_s6d02a1.c b/drivers/video/fbtft/fb_s6d02a1.c
similarity index 100%
rename from drivers/staging/fbtft/fb_s6d02a1.c
rename to drivers/video/fbtft/fb_s6d02a1.c
diff --git a/drivers/staging/fbtft/fb_s6d1121.c b/drivers/video/fbtft/fb_s6d1121.c
similarity index 100%
rename from drivers/staging/fbtft/fb_s6d1121.c
rename to drivers/video/fbtft/fb_s6d1121.c
diff --git a/drivers/staging/fbtft/fb_seps525.c b/drivers/video/fbtft/fb_seps525.c
similarity index 100%
rename from drivers/staging/fbtft/fb_seps525.c
rename to drivers/video/fbtft/fb_seps525.c
diff --git a/drivers/staging/fbtft/fb_sh1106.c b/drivers/video/fbtft/fb_sh1106.c
similarity index 100%
rename from drivers/staging/fbtft/fb_sh1106.c
rename to drivers/video/fbtft/fb_sh1106.c
diff --git a/drivers/staging/fbtft/fb_ssd1289.c b/drivers/video/fbtft/fb_ssd1289.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1289.c
rename to drivers/video/fbtft/fb_ssd1289.c
diff --git a/drivers/staging/fbtft/fb_ssd1305.c b/drivers/video/fbtft/fb_ssd1305.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1305.c
rename to drivers/video/fbtft/fb_ssd1305.c
diff --git a/drivers/staging/fbtft/fb_ssd1306.c b/drivers/video/fbtft/fb_ssd1306.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1306.c
rename to drivers/video/fbtft/fb_ssd1306.c
diff --git a/drivers/staging/fbtft/fb_ssd1325.c b/drivers/video/fbtft/fb_ssd1325.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1325.c
rename to drivers/video/fbtft/fb_ssd1325.c
diff --git a/drivers/staging/fbtft/fb_ssd1331.c b/drivers/video/fbtft/fb_ssd1331.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1331.c
rename to drivers/video/fbtft/fb_ssd1331.c
diff --git a/drivers/staging/fbtft/fb_ssd1351.c b/drivers/video/fbtft/fb_ssd1351.c
similarity index 100%
rename from drivers/staging/fbtft/fb_ssd1351.c
rename to drivers/video/fbtft/fb_ssd1351.c
diff --git a/drivers/staging/fbtft/fb_st7735r.c b/drivers/video/fbtft/fb_st7735r.c
similarity index 100%
rename from drivers/staging/fbtft/fb_st7735r.c
rename to drivers/video/fbtft/fb_st7735r.c
diff --git a/drivers/staging/fbtft/fb_st7789v.c b/drivers/video/fbtft/fb_st7789v.c
similarity index 100%
rename from drivers/staging/fbtft/fb_st7789v.c
rename to drivers/video/fbtft/fb_st7789v.c
diff --git a/drivers/staging/fbtft/fb_tinylcd.c b/drivers/video/fbtft/fb_tinylcd.c
similarity index 100%
rename from drivers/staging/fbtft/fb_tinylcd.c
rename to drivers/video/fbtft/fb_tinylcd.c
diff --git a/drivers/staging/fbtft/fb_tls8204.c b/drivers/video/fbtft/fb_tls8204.c
similarity index 100%
rename from drivers/staging/fbtft/fb_tls8204.c
rename to drivers/video/fbtft/fb_tls8204.c
diff --git a/drivers/staging/fbtft/fb_uc1611.c b/drivers/video/fbtft/fb_uc1611.c
similarity index 100%
rename from drivers/staging/fbtft/fb_uc1611.c
rename to drivers/video/fbtft/fb_uc1611.c
diff --git a/drivers/staging/fbtft/fb_uc1701.c b/drivers/video/fbtft/fb_uc1701.c
similarity index 100%
rename from drivers/staging/fbtft/fb_uc1701.c
rename to drivers/video/fbtft/fb_uc1701.c
diff --git a/drivers/staging/fbtft/fb_upd161704.c b/drivers/video/fbtft/fb_upd161704.c
similarity index 100%
rename from drivers/staging/fbtft/fb_upd161704.c
rename to drivers/video/fbtft/fb_upd161704.c
diff --git a/drivers/staging/fbtft/fbtft-bus.c b/drivers/video/fbtft/fbtft-bus.c
similarity index 100%
rename from drivers/staging/fbtft/fbtft-bus.c
rename to drivers/video/fbtft/fbtft-bus.c
diff --git a/drivers/staging/fbtft/fbtft-core.c b/drivers/video/fbtft/fbtft-core.c
similarity index 100%
rename from drivers/staging/fbtft/fbtft-core.c
rename to drivers/video/fbtft/fbtft-core.c
diff --git a/drivers/staging/fbtft/fbtft-io.c b/drivers/video/fbtft/fbtft-io.c
similarity index 100%
rename from drivers/staging/fbtft/fbtft-io.c
rename to drivers/video/fbtft/fbtft-io.c
diff --git a/drivers/staging/fbtft/fbtft-sysfs.c b/drivers/video/fbtft/fbtft-sysfs.c
similarity index 100%
rename from drivers/staging/fbtft/fbtft-sysfs.c
rename to drivers/video/fbtft/fbtft-sysfs.c
diff --git a/drivers/staging/fbtft/fbtft.h b/drivers/video/fbtft/fbtft.h
similarity index 100%
rename from drivers/staging/fbtft/fbtft.h
rename to drivers/video/fbtft/fbtft.h
diff --git a/drivers/staging/fbtft/internal.h b/drivers/video/fbtft/internal.h
similarity index 100%
rename from drivers/staging/fbtft/internal.h
rename to drivers/video/fbtft/internal.h